function isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _construct(Parent, args, Class) { if (isNativeReflectConstruct()) { _construct = Reflect.construct; } else { _construct = function _construct(Parent, args, Class) { var a = [null]; a.push.apply(a, args); var Constructor = Function.bind.apply(Parent, a); var instance = new Constructor(); if (Class) _setPrototypeOf(instance, Class.prototype); return instance; }; } return _construct.apply(null, arguments); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

import { Scope } from './Scope';
export var Context =
/*#__PURE__*/
function () {
  function Context(module, element, args) {
    _classCallCheck(this, Context);

    this.module = module;
    this.element = element;
    var params = args || [null];
    var props = this.module.application.props;
    this.scope = new Scope(this.schema, this.slug, element, props); // Args are used only for "mix" [no]components

    if (element) {
      try {
        this.component = _construct(module.ComponentConstructor, [this].concat(_toConsumableArray(params)));
        this.component.load();
      } catch (error) {
        this.handleError(error, "loading component [".concat(this.slug, "]"));
      }
    } else {
      this.component = _construct(module.ComponentConstructor, [this].concat(_toConsumableArray(params)));
      this.init();
    }
  }

  _createClass(Context, [{
    key: "init",
    value: function init() {
      try {
        this.component.init();
      } catch (error) {
        this.handleError(error, "initializing component [".concat(this.slug, "]"));
      }
    }
  }, {
    key: "destroy",
    value: function destroy() {
      try {
        this.component.destroy();
      } catch (error) {
        this.handleError(error, "destroying component [".concat(this.slug, "]"));
      }
    }
  }, {
    key: "bindAll",
    value: function bindAll() {
      try {
        this.component.bindAll();
      } catch (error) {
        this.handleError(error, "binding component [".concat(this.slug, "]"));
      }
    }
  }, {
    key: "unbindAll",
    value: function unbindAll() {
      try {
        this.component.unbindAll();
      } catch (error) {
        this.handleError(error, "unbinding component [".concat(this.slug, "]"));
      }
    }
  }, {
    key: "unsubscribeAll",
    value: function unsubscribeAll() {
      try {
        this.component.unsubscribeAll();
      } catch (error) {
        this.handleError(error, "unsubscribing component [".concat(this.slug, "]"));
      }
    }
  }, {
    key: "handleError",
    // Error handling
    value: function handleError(error, message) {
      var detail = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
      var identifier = this.identifier,
          component = this.component,
          element = this.element; // eslint-disable-next-line no-param-reassign

      detail = Object.assign({
        identifier: identifier,
        component: component,
        element: element
      }, detail);
      this.application.handleError(error, message, detail);
    }
  }, {
    key: "application",
    get: function get() {
      return this.module.application;
    }
  }, {
    key: "slug",
    get: function get() {
      return this.module.slug;
    }
  }, {
    key: "schema",
    get: function get() {
      return this.application.schema;
    }
  }]);

  return Context;
}();