function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

import { Context } from './Context';
export var Module =
/*#__PURE__*/
function () {
  function Module(application, definition, args) {
    _classCallCheck(this, Module);

    this.application = application;
    this.definition = definition;
    this.args = args;
    this.contextsByElement = new WeakMap();
    this.contextsByNoElement = new Map();
    this.initializedContexts = new Set();
  }

  _createClass(Module, [{
    key: "initElement",
    value: function initElement(element, args) {
      var context = this._fetchContextForElement(element, args);

      if (context && !this.initializedContexts.has(context)) {
        this.initializedContexts.add(context);
        context.init();
        context.bindAll();
      }
    }
  }, {
    key: "initNoElement",
    value: function initNoElement(slug, args) {
      var context = this._fetchContextForNoElement(slug, args);

      if (context && !this.initializedContexts.has(context)) {
        this.initializedContexts.add(context);
        context.bindAll();
      }
    }
  }, {
    key: "destroyElement",
    value: function destroyElement(element) {
      var context = this._fetchContextForElement(element);

      if (context && this.initializedContexts.has(context)) {
        this.initializedContexts.delete(context);
        context.unbindAll();
        context.unsubscribeAll();
        context.destroy();
      }
    }
  }, {
    key: "destroyNoElement",
    value: function destroyNoElement(slug) {
      var context = this._fetchContextForNoElement(slug);

      if (context && this.initializedContexts.has(context)) {
        this.initializedContexts.delete(context);
        context.unbindAll();
        context.unsubscribeAll();
        context.destroy();
      }
    } // Private

  }, {
    key: "_fetchContextForElement",
    value: function _fetchContextForElement(element, args) {
      var context = this.contextsByElement.get(element);

      if (!context) {
        context = new Context(this, element, args);
        this.contextsByElement.set(element, context);
      }

      return context;
    }
  }, {
    key: "_fetchContextForNoElement",
    value: function _fetchContextForNoElement(slug, args) {
      // eslint-disable-line id-length
      var context = this.contextsByNoElement.get(slug);

      if (!context) {
        context = new Context(this, null, args);
        this.contextsByNoElement.set(slug, context);
      }

      return context;
    }
  }, {
    key: "slug",
    get: function get() {
      return this.definition.slug;
    }
  }, {
    key: "ComponentConstructor",
    get: function get() {
      return this.definition.ComponentConstructor;
    }
  }, {
    key: "contexts",
    get: function get() {
      return Array.from(this.initializedContexts);
    }
  }]);

  return Module;
}();